<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">

<mapper namespace="py.pol.una.ii.pw.mybatis.mapper.PaymentMapper">

    <resultMap type="PaymentBean" id="resultPayments">
        <result property="id" column="id" />
        <result property="clientId" column="client_id" />
        <result property="total" column="total" />
        <result property="date" column="date" />
    </resultMap>

    <select id="getPaymentById" parameterType="Long" resultType="PaymentBean">
        SELECT id, client_id as clientId, total, date 
        FROM payment where id = #{id};
    </select>

    <insert id="newPayment" parameterType="PaymentBean"
        useGeneratedKeys="true" keyProperty="id">
        <selectKey keyProperty="id" resultType="long"
			order="BEFORE">
			SELECT nextVal('payment_id_seq')
		</selectKey>
        INSERT INTO payment(id, client_id, total, date) VALUES
        (#{id}, #{clientId}, #{total}, #{date});
    </insert>

    <select id="getAllPayments" resultMap="resultPayments">
        SELECT * FROM payment;
    </select>

    <update id="updatePayment" parameterType="PaymentBean">
        UPDATE payment
        SET
        client_id = #{clientId},
        total = #{total},
        date = #{date},
        WHERE id = #{id};
    </update>

    <delete id="deletePayment" parameterType="PaymentBean">
        DELETE FROM payment WHERE id = #{id};
    </delete>

</mapper>